
Unit Rand3;

(* Don't use this unit together with RANGEN. *)

Interface

(* Random number generator comes from Press, Teukolsky & Vetterling *)

FUNCTION randomint(k: Integer): Integer;
(* random integer from 1 to k *)

FUNCTION random3: Extended;
(* Subtractive method *)

PROCEDURE init3(seed: longint);
(* Initialises random3 *)

FUNCTION takeseed3: longint;

procedure randomize3(var sr: shortstring);

Implementation

uses SysUtils;

VAR
   glinext,glinextp: longint;
   glma: ARRAY [1..55] OF Extended;
   m3seed: extended;
   idum3: integer; (* indicates whether initialisation has taken place *)

FUNCTION ran3(var idum: integer): Extended;
CONST
   mbig=4.0e6;
   mz=0.0;
   fac=2.5e-7; (* 1/mbig *)
VAR
   i,ii,k: integer;
   mj,mk: Extended;
BEGIN
   IF (idum < 0) THEN BEGIN
      mj := m3seed+idum;
      (* The following IF block is mj := mj MOD mbig; for Extended variables. *)
      IF mj>=0.0 THEN mj := mj-mbig*trunc(mj/mbig)
         ELSE mj := mbig-abs(mj)+mbig*trunc(abs(mj)/mbig);
      glma[55] := mj;
      mk := 1;
      FOR i := 1 to 54 DO BEGIN
         ii := 21*i MOD 55;
         glma[ii] := mk;
         mk := mj-mk;
         IF (mk < mz) THEN mk := mk+mbig;
         mj := glma[ii]
      END;
      FOR k := 1 to 4 DO BEGIN
         FOR i := 1 to 55 DO BEGIN
            glma[i] := glma[i]-glma[1+((i+30) MOD 55)];
            IF (glma[i] < mz) THEN glma[i] := glma[i]+mbig
         END
      END;
      glinext := 0;
      glinextp := 31;
      idum := 1
   END; (* if idum < 0 *)
   glinext := glinext+1;
   IF (glinext = 56) THEN glinext := 1;
   glinextp := glinextp+1;
   IF (glinextp = 56) THEN glinextp := 1;
   mj := glma[glinext]-glma[glinextp];
   IF (mj < mz) THEN mj := mj+mbig;
   glma[glinext] := mj;
   ran3 := 0.00000000001 + 0.99999999998*mj*fac
END; (* ran3 *)

FUNCTION random3: Extended;
begin
  random3 := ran3(idum3);
end;

FUNCTION randomint(k: Integer): Integer;
(* random integer from 1 to k *)
var ri: integer;
begin
  ri := trunc(random3*k) + 1;
  if (ri < 1) then ri := 1;
  if (ri > k) then ri := k;
  randomint := ri;
end;

PROCEDURE init3(seed: longint);
(* Initialises random3 *)
begin
 m3seed := seed;
 idum3 := -1;
end;

FUNCTION takeseed3: longint;
var s: longint;
begin
  s := trunc(4.0e6*ran3(idum3));
  init3(s);
  takeseed3 := s;
end;

procedure randomize3(var sr: shortstring);
var s: longint;
begin
  randomize;
  s := trunc(random * 12345678);
  init3(s);
  sr := 'Random number generator initialized randomly at '+inttostr(s)+'.';
end;

begin (* unit *)
m3seed := 1618033.0;
idum3 := -1;
end.
