             (*       ZOLIB.PAS        *)

unit ZOLIB;

interface


type Ress = array[1..70] of Real;

function Root(x: Real): Real;
procedure Barchart(var f: Textfile; w: byte; barwidth,barnum,n0: Integer;
                   Var mean, sd: Ress);

procedure Preparations(var pn: shortstring; var ouf: textfile);

procedure Outputfile(fn: shortstring; var f: textfile);
(* output file named fn is attached;
   its previous existence determines whether output is appended
   to an existing file of this name;
   The file gets a header with filename and date. *)

procedure NiceString(x: real; var s: shortstring);

procedure Heading(level: byte; var f: textfile; s: string);

procedure parse(var s: shortstring);
(* takes away out of s all characters with ASCII numbers less than 33 *)

var ZOVersion: shortstring;

implementation

uses SysUtils;



function Root(x: Real): Real;
begin
  if x > 1e-36 then Root := sqrt(x) else Root := 0.0;
end; (* Root *)


procedure Barchart(var f: Textfile; w: byte; barwidth,barnum,n0: Integer;
                   Var mean, sd: Ress);
var i, i0, i1, ii, j, k, m, n, xstep, xmax, xdiv, ydiv, ymax: Integer;
    yplus, y, z, ystep, sa, sb: Real;
    p: array[1..80,1..25] of string[1];
    s: string;
    int,int2: integer;
    endpoint: array[1..80] of byte;
    empty: boolean;

begin
 writeln(f);
  if (barwidth <= 0) or (barnum <= 1) then Exit;

  for i:= 1 to 80 do for j:=1 to 25 do p[i,j] := ' ';
  n := barnum;
  i0 := 1;
  i1 := barnum;
  yplus:= 0.0;
  for i:= i0 to i1 do
    if mean[i] + 2.0*sd[i] > yplus then yplus:= mean[i] + 2.0*sd[i];
  if n <= 15 then
    xstep := 4 else
      begin
        if n <= 30 then xstep := 2 else xstep := 1
        end;
  xmax := n*xstep;
  if xmax > 71 then xmax := 71;
  if xmax <= 42 then ymax := (xmax + 1) div 2  else ymax := 21;
  ystep := yplus/ymax;
  y := ystep;
  z := 1.0;
  repeat
    begin
      y:=y*10.0;
      z:= z/10.0;
      m:= trunc(y);
    end
    until m > 0;
  m := m+1;
(* this implies  (m-1)*z <= ystep < m*z   *)
  if m=2 then
    begin
      if ystep > 1.5*z then ystep := 2.0*z
       else
       begin if ystep > 1.25*z then ystep:= 1.5*z
        else ystep := 1.25*z
       end
    end else
     begin
       if ystep < 2.5*z then ystep := 2.5*z else
         ystep := m*z
     end;
  ymax := trunc(yplus/ystep) + 1;
  if ymax <= 8 then ydiv := 1 else ydiv := 2;
  if xstep <= 2 then xdiv := 5 else xdiv := 1;

  (* draw vertical axis *)

  for int:= 1 to 80 do for int2:= 1 to 24 do p[int,int2]:= ' ';

  for i:= 0 to ymax do
    begin
    if i div ydiv >= i/ydiv - 1E-4 then  begin
       str(i*ystep:6:4,s);
       for int:= 1 to 6 do p[int,22-i]:= copy(s,int,1);
       p[7,22-i]:=  '|'; (* chr(180); *)
      end else p[7,22-i]:=  '|'; (*  chr(179);   *)
   end;
 (* draw horizontal axis *)
  for i:= i0 to i1 do
    begin
    ii := i - i0 + 1;
    if ii div xdiv >= ii/xdiv - 1E-4 then
      begin
        if xstep >= 4 then
            begin
             p[8 + (ii-1)*xstep,23]:= '-'; (* chr(196); *)
             p[9 + (ii-1)*xstep,23]:= '-'; (* chr(196); *)
             p[10 + (ii-1)*xstep,23]:= '-'; (* chr(196); *)
             p[11 + (ii-1)*xstep,23]:= '-'; (* chr(194); *)
            end else
          begin if xstep = 2 then begin
           p[8 + (ii-1)*xstep,23]:= '-'; (* chr(196); *)
           p[9 + (ii-1)*xstep,23]:= '-'; (* chr(194); *)
          end else begin
          p[8 + (ii-1)*xstep,23]:= '-'; (* chr(194); *)
          end; end;
       str(n0+((i-1)*barwidth):2,s);
       for int:= 1 to 2 do p[int+ 5 + ii*xstep,24]:= copy(s,int,1);
      end else begin
      for k:= 1 to xstep do p[7+k + (ii-1)*xstep,23]:= '-'; (* chr(196); *)
      end;
    end;
  p[7,23]:= '+';(* chr(197); *)

  (* draw bars *)
  for i:= i0 to i1 do
    begin
    ii := i - i0 + 1;
    j:= 0;
    sa := mean[i] - 2.0*sd[i];
    sb := mean[i] + 2.0*sd[i];
    if (mean[i] > 1e-8) then
      begin
      while (j*ystep < sb) do
        begin
        if (j*ystep <= sa) then
          begin
            if xstep <= 2 then
begin
  p[7 + ii*xstep,22-j]:= 'X'; (* chr(178)); *)
 end else begin
  p[10 + (ii-1)*xstep,22-j]:= 'X'; (* chr(178); *)
  p[11 + (ii-1)*xstep,22-j]:= 'X'; (* chr(178); *)
 end;
end
           else
         begin
           if xstep <= 2 then  begin
            p[7 + ii*xstep,22-j]:= 'x'; (* chr(177); *)
           end else
begin
  p[10 + (ii-1)*xstep,22-j]:= 'x'; (* chr(177); *)
  p[11 + (ii-1)*xstep,22-j]:= 'x'; (* chr(177); *)
 end;
end;
         j := j+1;
        end;      (* while *)
      end; (* if *)
    end; (* for i *)

  if (w <= 1) then
    begin (* horizontal chart *)
      for int2:= 1 to 24 do
        begin
          empty := true;
          if empty then for int :=1 to 79 do if (p[int,int2] <> ' ')
            then empty := false;
          if (not empty) then begin
            for int:= 1 to 79 do write(f,p[int,int2]);
            writeln(f);
           end;
         end;
     end else begin (* vertical chart *)
       empty := true;
       for int:= 1 to 80 do begin
          if empty then for int2 :=1 to 24 do if (p[int,int2] <> ' ')
            then empty := false;
          if (not empty) then begin
            for int2:= 1 to 24 do write(f,p[int,int2]);
            writeln(f);
           end;
        end;
      end;
end (* Barchart *);


procedure Outputfile(fn: shortstring; var f: textfile);
var i: integer;
    appf: boolean;
begin
  appf := FileExists(fn);
  assignfile(f,fn);
if appf then begin
  append(f);
  writeln(f);
  writeln(f,'Results appended to existing file ',fn,'.');
  writeln(f,'Date and time: '+DateTimeToStr(Now));
  writeln(f); writeln(f);
 end else begin
  rewrite(f);
  write(f,'                        ************');
  for i:=length(fn) downto 1 do write(f,'*');
  writeln(f);
  writeln(f,'                              ',fn);
  write(f,'                        ************');
  for i:=length(fn) downto 1 do write(f,'*');
  writeln(f);
  writeln(f);
  writeln(f,'Filename is ',fn,' .');
  writeln(f);
  writeln(f,'Date and time: '+DateTimeToStr(Now));
  writeln(f); writeln(f);
 end;
end;


procedure NiceString(x: real; var s: shortstring);
var j: integer;
 s1: string;
begin
  str(x:12:4,s1);
  if (length(s1) < 12) then for j:=12-length(s1) downto 1 do s1 := ' '+s1;
  if (copy(s1,9,4) = '0000') then begin
    str(x:7:0,s1);
    s1 := s1+'    ';
     if (length(s1) < 12) then
      for j:=12-length(s1) downto 1 do s1 := ' '+s1; 
  end;
  s := s1;
end; (* NiceString *)

procedure Heading(level: byte; var f: textfile; s: string);
var i,sl: integer;
begin
  sl := length(s);
  writeln(f);
  writeln(f,'@',level);
  writeln(f,s);
  case level of
    1: begin
         for i:=1 to sl do write(f,'=');
         writeln(f);
        end;
    2: begin
         for i:=1 to sl do write(f,'-');
         writeln(f);
        end;
    end; (* case *)
  writeln(f);
end;

procedure parse(var s: shortstring);
(* takes away out of s all characters with ASCII numbers less than 33 *)
var s1: shortstring;
 x: char;
 i,n: integer;
begin
 n := length(s);
 s1 := '';
 for i:=1 to n do begin
   x := s[i];
   if (ord(x) >= 33) then s1 := s1+x;
  end;
 s := s1;
end;

procedure Preparations(var pn: shortstring; var ouf: textfile);
var outfn: shortstring;
begin (* Preparations *)
  if (ParamCount >= 1) then pn := ParamStr(1) else pn := 'ZO';
  outfn := pn+'.out';
  outputfile(outfn,ouf);
  Heading(1,ouf,'ZO version '+ZOVersion);
  if (ParamCount = 0) then begin
    writeln(ouf,'Warning: no project name given.');
    write(ouf,'Default p');
   end else write(ouf,'P');
  writeln(ouf,'roject name <<',pn,'>>.');
end; (* Preparations *)



begin (* unit ZOlib *)

ZOVersion := '2.3';

end.
