unit ZOS_FORM;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs, Simul, ZOlib, ZOSimlib, SimPlus,
  StdCtrls, Buttons, jpeg, ExtCtrls;

type
  TZOSimForm = class(TForm)
    NumberSim: TEdit;
    NumberAttempt: TEdit;
    NumberLabel: TLabel;
    TerminateLabel: TLabel;
    AttemptLabel: TLabel;
    PrelimLabel: TLabel;
    Image1: TImage;
    RangeLabel: TLabel;
    StopBackground: TLabel;
    StopLabel: TLabel;
    OKEdit: TEdit;
    procedure shownumber(nn: integer);
    procedure showattempt(nn: integer);
    procedure FormActivate(Sender: TObject);
    procedure ProcessThem;
(* this procedure is activated when the form opens:
   see Object Inspector, Events, OnActivate *)
    procedure HaltOnEsc(Sender: TObject);
    procedure Formclose(Sender: TObject);
    procedure CloseForm(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ZOSimForm: TZOSimForm;
  proname: shortstring;  (* proname = project name *)
  ready: boolean;

implementation


procedure TZOSimForm.shownumber(nn: integer);
var s: shortstring;
begin
  str(nn,s);
  numbersim.text := '       '+ s;
end;

procedure TZOSimForm.showattempt(nn: integer);
var s: shortstring;
begin
  str(nn,s);
  numberattempt.text := '       '+ s;
end;

procedure TZOSimForm.processthem;
begin
  Application.ProcessMessages;
end;

{$R *.DFM}

procedure TZOSimForm.FormActivate(Sender: TObject);
begin
  ready := false;
  Preparations(proname,outf);
  ReadInFile(outf,proname);
  caption := 'ZO Simulation '+proname;
  RangeLabel.caption := '(1 - '+inttostr(nrun)+')';  
  if (errtext > '') then begin
    PrelimLabel.caption:= errtext;
    PrelimLabel.visible := true;
    haltit := true;
   end;
  if ((f >= 2) and (nrun >= 2)) then begin
    Simulate(true,f,g,mode,strzer,presmuts,rt,ct,weit,numl,nrun,
           errtext,warntext,mutzero,nsuc,ntry,
           small,large,s,s2,c,sp,sp2,sl,s2l,cl,ssl);
    if (errtext > '') then begin
      writeln(outf,errtext);
      PrelimLabel.caption:= errtext;
      PrelimLabel.visible := true;
     end;
    if ((errtext > '') and (not halted)) then haltit := true;
    if (not haltit) then begin
      Result0(outf,mode);
      if UseResfile then begin
        PrelimLabel.caption:='processing results ...';
        PrelimLabel.visible := true;
        StopLabel.visible := false;
        StopBackground.visible := false;
        Application.ProcessMessages;
        SimPlusCalculations;
        PrelimLabel.visible := false;
       end else begin
       Calcresult(nrun, numf, numl, numl2,
                   sp, sp2, s, s2, c, sl, s2l, cl, ssl,
            meanp,varp, mean,sd,cummean,cumsd, meanl,sdl,covl);
        GiveResult(outf);
       end;
     end; (* if not haltit *)
    end (* if f >= 2 *) else Result0(outf,mode);
  ready := true;
  if printfileconn then begin   
    writeln(outf);
    writeln(outf,'Simulated matrices were written to file ',pname,'.');
    closefile(pfile);
   end;
  writeln(outf);
  closefile(outf);
  OKEdit.enabled := true;
  if haltit then
    TerminateLabel.caption := 'The program had to stop.';
  StopLabel.visible := false;
  StopBackground.visible := false;
  OKEdit.visible := true;
  TerminateLabel.visible := true;
  hint := 'click OK to continue';
end;

procedure TZOSimForm.HaltOnEsc(Sender: TObject);
begin
  Displays(ntry,nsuc);
  if MessageDlg(
  'Are you sure you want to stop the simulations?',
  mtConfirmation,[mbYes, mbNo],1) = mrYes
    then begin
      halted := true;
      TerminateLabel.caption := ' The program was interrupted';
      writeln(outf,'Simulations terminated early by user.');
     end;
end;

procedure TZOSimForm.Formclose(Sender: TObject);
begin
  if (halted or haltit or (nsuc >= nrun)) then ZOSimForm.close;
end;


procedure TZOSimForm.CloseForm(Sender: TObject; var Action: TCloseAction);
begin
 if not ready then begin
   halted := true;
   writeln(outf,'Program closed by user.');
  end;
end;

end.
