unit enum_cons;

interface

const
  fmax = 15; gmax = 15;  (* maximum order of incidence matrix  *)
  fgmax = 15;            (* maximum of fmax and gmax *)
  hmax = 100;        (* maximum number of node levels; less than 256! *)
  m1 = 0;           (* m1 and m2 are bounds of arrays used for    *)
  m2 = 100;           (* function evaluation                        *)
  m01 = 2;
  numfmax = 15;       (* maximum number of functions evaluated;
              should be equal to fgmax in current implementation of FUNCTEN *)

type
  Row = array[1..fmax] of Boolean;
  Col = array[1..gmax] of Boolean;
  Incid = array[1..fmax,1..gmax] of Boolean;   (* incidence matrix *)
  RIncid = array[1..fmax,1..gmax] of Real;
  RVector = array[1..gmax] of Real;
  IVector = array[1..gmax] of longint;
  Sumsc = array[0..hmax,1..gmax] of Byte;
  Sumsr = array[0..hmax,1..fmax] of Byte;
  Remember = array[0..hmax] of Byte;
  Bomember = array[0..hmax] of Boolean;
  Bigmember = array[0..hmax,1..numfmax] of Integer;
  Res  = array[m1..m2,1..numfmax] of Real; (* for bookkeeping of results *)
  Res0 = array[1..m01,1..numfmax] of Real; (* idem *)
  Switch  = array[1..hmax] of Byte;
  Level   = array[1..fmax,1..gmax] of Byte;
  Margin = array[1..fgmax] of Byte;
  Marginr = array[1..fmax] of Byte;
  Marginc = array[1..gmax] of Byte;
  Funcvalue = array[1..numfmax] of Integer;
  rFuncvalue = array[1..numfmax] of real;

var
  f,g,h,istar,jstar: Byte;           (* order of matrix *)
  numf, nums: integer;  (* number of functions evaluated; number of functions
                        primarily updated *)
  fversion: Byte;      (* choice of statistics evaluated *)
  kmax: longint;
  presmuts: Integer;
           (* prescribed number of mutual dyads in mode mutfix *)
  printall, full, digr, graph, gnrl, connect, mutfix,
          calcnum: Boolean;
  rzer,rt: Marginr;             (* row totals *)
  czer,ct: Marginc;             (* column totals *)
  mat: Incid;         (* mat = incidence matrix being produced  *)
  mut: Remember;
  sumfn: Bigmember;             (* preliminary value of evaluated functions *)
  StrZer: Incid;                (* indicator matrix of structural zeros *)
  s00, Ndisconn: longint;  (* number of graphs constructed *)
  s0: Res0;
  s: Res;     (* sums of results *)
  m3, m4: array[1..numfmax] of Integer;
  large, small: array[1..numfmax] of Boolean;

implementation

end.
