             (*       ZOELIB.PAS        *)

unit Zoelib;

interface

uses Enum_cons;


procedure readinfile(var outf: textfile; proname: shortstring);
function sumr(a: Marginc): Integer ;
function sumc(a: Marginr): Integer ;
{procedure GetMat(var x: Incid; var r: Marginr; var c: Marginc);}
procedure Startpfile(var pfile: textfile; rt: Marginr; ct: Marginc);
procedure Update(var rfout: RFuncvalue);
procedure Giveresult(var outf: textfile);
procedure Listmat(var outf, pfile: textfile; rfv: RFuncvalue);

implementation

Uses SysUtils, Functen, ZOLib, ZOE_Form;


function sumr(a: Marginc): Integer ;
var x: integer;
    k: integer;
begin
 x := 0;
 for k:= 1 to g do x:= x + a[k];
 sumr := x;
end; (* sumr *)

function sumc(a: Marginr): Integer ;
var x: integer;
    k: integer;
begin
 x := 0;
 for k:= 1 to f do x:= x + a[k];
 sumc := x;
end; (* sumc *)



{
procedure GetMat(var x: Incid; var r: Marginr; var c: Marginc);
var idum: Integer;
    i, j: integer;
    fn: String[15];
    infl: Textfile;
begin
    writeln; readln;
    write('Give file name : ');
    readln(fn);
    assign(infl,fn);
    reset(infl);
    for j:= 1 to g do c[j] := 0;
    for i:= 1 to f do begin
      r[i] := 0;
      for j := 1 to g do begin
        read(infl,idum);
        x[i,j] := (idum >= 1);
        if x[i,j] then begin
          r[i] := r[i] + 1;
          c[j] := c[j] + 1;
         end; (* if *)
       end; (* j *)
      readln(infl);
     end; (* i *)
    close(infl);
    clrscr;
    writeln('The matrix read is the following.');
    writeln; writeln;
    for i:= 1 to f do begin
      for j := 1 to g do
        if x[i,j] then write('  1') else write('  0');
      writeln('   ', r[i]);
     end; (* i *)
    for j:= 1 to g do write(c[j]:3);
   writeln;
   WaitKey;
end; (* GetMat *)
}


procedure readinfile(var outf: textfile; proname: shortstring);
(* If an error is encountered, this procedure is exited with f = g = 0 . *)
var infn, datfn, ts: shortstring;
 inf, datf: textfile;
 dum, dumij, i, j, iend, jend, fgm, CheckNumber: integer;
 good, datmatrix, symm, SameDegrees: boolean;
 dmat: Incid;
 fuv: funcvalue; rfuv: rfuncvalue;
begin
(*
dimension f
dimension g
graph mode: 1 = full, 2 = digr, 3 = graph, 4 = arbitrary
write mode: 0 = no print, 1 = print ("printall")
0 for marginal totals file, 1 for adjacency file
file name
connected mode: 0 = no, 1 = yes
if digr then mutuals mode: 0 = no, 1 = yes
if mutuals then presmuts
if gnrl then file name with structural zeros   <this line may be absent>
version for evaluated statistics: truncated if not between 1 and NumVersion
*)
  ZOForm.caption := 'ZO Enumeration '+proname;
  heading(2,outf,'Reading input files.');
  infn := proname+'.in';
  if (not FileExists(infn)) then begin
    writeln(outf,'Error: file ',infn,' is not found.');
    f := 0; g := 0;
    exit;
   end;
  assign(inf,infn);
  reset(inf);
  writeln(outf,'input file ',infn);
  readln(inf,f);
  readln(inf,g);
  writeln(outf,f,' rows, ',g,' columns.');
  if ((f <= 2) or (g <= 2)) then begin
    writeln(outf,'This is not meaningful.');
    f := 0; g := 0;
   end;
  readln(inf,dum);
  full := false;
  digr := false;
  graph := false;
  gnrl := false;
  case dum of
    1: full := true;
    2: digr := true;
    3: graph := true;
    4: gnrl := true;
    else begin
      writeln(outf,'Error: code ',dum,' not allowed as type of matrix.');
      f := 0; g := 0;
     end;
   end; (* case *)
  if (graph or digr) then begin
    g := f;
   end;
  readln(inf,dum);
  printall := (dum > 0);
  readln(inf,dum);
  readln(inf,datfn);
  if (not FileExists(datfn)) then begin
    writeln(outf,'Error: data file ',datfn,' is not found.');
    f:=0; g := 0;
   end;
  if (f*g = 0) then exit;

(* read data file: *)
  assign(datf,datfn);
  reset(datf);
  if (dum <= 0) then begin (* marginal totals file *)
    datmatrix := false;
    writeln(outf,'Marginal totals read from file ',datfn,'.');
    for i:=1 to f do read(datf,rt[i]);
    readln(datf);
    if (not (graph or Eof(datf))) then begin
      for i:=1 to g do read(datf,ct[i]);
     end else begin
       g := f;
       for i:=1 to g do ct[i] := rt[i];
      end;
    if (f=g) then begin
      SameDegrees := true;
      for i:=1 to f do if (ct[i] <> rt[i]) then SameDegrees := false;
     end else SameDegrees := false;
   end else begin (* adjacency matrix file *)
    datmatrix := true;
    symm :=true;
    writeln(outf,
     'Marginal totals calculated from adjacency matrix in file ',datfn,'.');
    for i:=1 to fmax do rt[i] := 0;
    for j:=1 to gmax do ct[j] := 0;
    for i:=1 to f do begin
      for j:=1 to g do begin
        read(datf,dumij);
        if ((graph or digr) and (i=j)) then dumij := 0;
        dmat[i,j] := (dumij > 0);
        if (dumij > 0) then
          begin inc(rt[i]); inc(ct[j]);
           if (j < i) and (not dmat[j,i]) then symm := false;
          end;
       end; (* for j *)
      readln(datf);
      if (Eof(datf) and (i < f)) then begin
        writeln(outf,'Error: end of file ',datfn,' after reading line ',i);
        writeln(outf,'whereas ',f,' lines are expected.');
        f := 0; g := 0;
        exit;
       end;
     end; (* for i *)
    if (f=g) then begin
      write(outf,'Data matrix is');
      if (not symm) then write(outf,' not');
      writeln(outf,' symmetric.');
      SameDegrees := true;
      for i:=1 to f do if (rt[i] <> ct[i]) then SameDegrees := false;
     end;
   end; (* if adjacency data matrix *)
  closefile(datf);

  readln(inf,dum);
  connect := ((dum > 0) and (graph or digr));
  mutfix := false;
  if digr then begin
    readln(inf,dum);
    mutfix := (dum > 0);
    if mutfix then readln(inf,presmuts);
   end;

  writeln(outf,'Requested mode:');
  if full then writeln(outf,'no structural zeros.');
  if digr then begin
     write(outf,'square matrix with structurally zero diagonal');
     writeln(outf,' (directed graph).'); end;
  if mutfix then writeln(outf,'Number of mutual dyads ', presmuts,'.');
  if graph then begin
     write(outf,'symmetric square matrix with structurally zero diagonal');
     writeln(outf,' (undirected graph).'); end;
  if gnrl then writeln(outf,'general pattern of structural zeros.');
  if connect then begin
     write(outf,'Enumeration is restricted to');
     if digr then write(outf,' weakly');
     write(outf,' connected');
     if digr then writeln(outf,' digraphs.') else writeln(outf,' graphs.');
    end;

(* Carry out some initial assignments *)
  for i := 1 to fmax do rzer[i] := 0;
  for j := 1 to gmax do czer[j] := 0;
  if (digr or graph) then begin
    if (fmax >= gmax) then fgm := gmax else fgm := fmax;
    g := f;
    for i:= 1 to fgm do begin
      strzer[i,i] := true;
      rzer[i] := 1; czer[i] := 1; end; (* i *)
   end; (* if digr or graph *)

(* Input of structural zeros for general case *)
  CheckNumber := -99;
  if gnrl then begin
    readln(inf,datfn);
    CheckNumber := StrToIntDef(datfn,-99);
   end;
  if (gnrl and (CheckNumber = -99)) then begin
    (* datfn must be a file name *)
    writeln(outf,'Structural zeros read from file ',datfn,'.');
    if (not FileExists(datfn)) then begin
      writeln(outf,'Error: data file ',datfn,' for structural zeros is not found.');
      f:=0; g := 0;
      exit;
     end;
(* read data file: *)
    assign(datf,datfn);
    reset(datf);
    iend := 0; jend := 0;
    for i:= 1 to f do begin
      for j:= 1 to g do begin
        if (eof(datf) and (iend + jend = 0)) then begin
          iend := i; jend := j;
         end;
        read(datf,dum);
        strzer[i,j] := (dum >= 1);
        if strzer[i,j] then begin
          rzer[i] := rzer[i] + 1;
          czer[j] := czer[j] + 1;
         end; (* if *)
       end; (* j *)
      readln(datf);
     end; (* i *)
    closefile(datf);
    if (iend + jend > 0) then begin
      writeln(outf,'Unexpected end of file ',datfn,' when trying to read');
      writeln(outf,'position ',jend,' of line ',iend,'.');
     end;
   end; (* if CheckNumber = -99 *)
  if (gnrl and (CheckNumber <> -99)) then begin
    for i:=1 to fmax do for j:=1 to gmax do strzer[i,j] := false;
    writeln(outf,'No file name given for structural zeros.');
    writeln(outf,'Consequently, no structural zeros are assumed.');
   end;
  if gnrl then begin
    writeln(outf,'Structural zeros in following pattern : ');
    writeln(outf);
    for i:= 1 to f do begin
      for j:=1 to g do if strzer[i,j] then
        write(outf,'1') else write(outf,'0');
      writeln(outf);
     end;
    writeln(outf);
   end; (* if gnrl *)

  calcnum := false; 
  if ((CheckNumber = -99) and eof(inf)) then
    writeln(outf,'Warning: unexpected end of input file.');
  if (CheckNumber = -99) then readln(inf,dum) else dum := CheckNumber;
  if ((dum >= 1) and (dum <= numversion))
      then fversion := dum else fversion := 1;
  if (dum = 9) then begin
    fversion := 1;
    dum := 1;
    calcnum := true;
   end;
  if (dum <> fversion) then
    writeln(outf,'The number ',dum,' is not allowed as the version of evaluated statistics.');
  writeln(outf,'Selected version of evaluated statistics is ',fversion,'.');
  closefile(inf);

(* trivial checks *)
    if (graph and (not SameDegrees)) then begin
      graph := false; digr := true; mutfix := false;
      writeln(outf,'Out- and in-degrees are different.');
      writeln(outf,'Mode changed to digraph instead of graph.');
     end;
    writeln(outf);
    writeln(outf,'vertices');
    for i:= 1 to f do write(outf,i:3,' ');
    if (g > f) then for i:=f+1 to g do write(outf,i:3,' ');
    writeln(outf);
    writeln(outf,'row totals');
    for i:= 1 to f do write(outf,rt[i]:3,' '); writeln(outf);
    writeln(outf,'column totals');
    for i:= 1 to g do write(outf,ct[i]:3,' '); writeln(outf);
    good := true;
    for i:=1 to f do
      if not ((rt[i] >= 0) and (rt[i] + rzer[i] <= g)) then
        begin
        write(outf,'row total ', i, ' = ', rt[i], '.');
        writeln(outf,' This is impossible !'); good := false;
       end;
    for i:=1 to g do
      if not ((ct[i] >= 0) and (ct[i] + czer[i] <= f)) then
        begin
        write(outf,'column total ', i, ' = ', ct[i], '.');
        writeln(outf,' This is impossible !'); good := false;
       end;
   if  (sumc(rt) <> sumr(ct)) then
     begin
       writeln(outf,'The row and column totals do not have the same sum.');
       writeln(outf,'This is impossible.');
       good := false;
     end;
   if ((graph) and odd(sumc(rt))) then begin
     writeln(outf,
       'The degree sum is odd, which is impossible for an undirected graph.');
     good := false;
    end;
   if (mutfix) then
     if ((presmuts < 0) or (2*presmuts > sumc(rt))) then begin
       writeln(outf,'The precribed number of mutual dyads is ',presmuts,'.');
       writeln(outf,'This is impossible.');
       good := false;
     end;
   if (not good) then begin
     f := 0; g := 0;
     exit;
    end;

  if (datmatrix) then begin
    datfunc(dmat,fversion,fuv,rfuv);
    heading(3,outf,'Function values observed for this data matrix');
    for i:=1 to NumFunc(fversion) do begin
      ts := tex(fversion,i,true);
      if length(ts) < 60 then for j:=length(ts) to 59 do ts := ts+' ';
      writeln(outf,ts,fuv[i]:10);
     end;
    writeln(outf);
   end; (* if datmatrix *)
end; (* readinfile *)


procedure Startpfile(var pfile: textfile; rt: Marginr; ct: Marginc);
var i,j: integer;
begin
  writeln(pfile,'This file contains all found 0-1 matrices ');
  writeln(pfile,'with the desired row and column totals.');
  writeln(pfile,'Mutual dyads are indicated by M.');
  writeln(pfile);
  write(pfile,'Row totals :    ');
  for i:=1 to f do
    begin write(pfile,rt[i]:3);
    if ((i mod 20) = 0) then writeln(pfile); end;
  writeln(pfile); write(pfile,'Column totals : ');
  for i:=1 to g do
    begin write(pfile,ct[i]:3);
    if ((i mod 20) = 0) then writeln(pfile); end;
  writeln(pfile);
  if graph then writeln(pfile,'Undirected graph.');
  if digr then writeln(pfile,'Directed graph.');
  if full then writeln(pfile,'No structural zeros.');
  if mutfix then writeln(pfile,'Number of mutuals fixed at ', presmuts);
  if gnrl then begin
    writeln(pfile,'Structural zeros in following pattern : ');
    writeln(pfile);
    for i:= 1 to f do begin
      for j:=1 to g do if strzer[i,j] then
        write(pfile,'1') else write(pfile,'0');
      writeln(pfile);
     end;
    writeln(pfile);
   end;
  writeln(pfile,'Following each matrix are the following function values:');
  for i:=1 to numf do writeln(pfile,i:2,'. ',Tex(fversion,i,false));
  writeln(pfile);
end; (* Startpfile *)

{
procedure Listmatd(var pfile: textfile; rfv: Rfuncvalue);
var i,j: Byte;
begin
  writeln(pfile); write(pfile,'    ');
  for i:= 1 to g do write(pfile,ct[i]:3);
  writeln(pfile);
  for i := 1 to f do begin
    write(pfile,rt[i]:3,' ');
    for j:= 1 to g do
    if mat[i,j] then begin
     if digr then begin
      if (i=j) then write(pfile,'  1') else
        if mat[j,i] then write(pfile,'  M') else write(pfile,'  1')
     end (* digr *) else write(pfile,'  1');
       end (* mat *) else write(pfile,'   ');
    writeln(pfile);
   end; (* i *)
 writeln(pfile);
 for i :=1 to numf do
   writeln(pfile,'Function value ',i:2,' = ',rfv[i]:6:2);
 end; (* Listmatd *)
 }
procedure Listmat(var outf, pfile: textfile; rfv: RFuncvalue);
var i,j: Byte;
 d1,d2: Int64;
 frac: real;
begin
  if (s00 mod 1000 = 0) then begin
    d1 := diskfree(0);
    d2 := disksize(0);
    frac := d1/d2;
    if (frac < 0.05) then begin
      writeln(outf,'You are writing all matrices to disk on the file ',pfname,', ');
      writeln(outf,'but of the entire disk space only ',frac:4:2,' is free');
      writeln(outf,'after writing ',s00,' matrices.');
      writeln(outf,
      'In order to avoid filling up your entire disk space, writing file ',
      pfname,' is terminated.');
      if (s00 > 1000) then writeln(outf,
        'You are advised to delete this file, it may be huge.');
      printall := false;
      printfileconn := false;
      closefile(pfile);
      exit;
     end;
   end; (* if *)
  writeln(pfile);
  writeln(pfile,s00,'.');
  for i := 1 to f do begin
    for j:= 1 to i-1 do
      if mat[i,j] then begin
       if digr then begin
        if mat[j,i] then write(pfile,'M') else write(pfile,'1')
       end (* digr *) else write(pfile,'1');
       end (* mat *) else write(pfile,'0');
    if digr then write(pfile,'X') else
      if mat[i,i] then write(pfile,'1') else write(pfile,'0');
    for j:= i+1 to g do
      if mat[i,j] then begin
       if digr then begin
        if mat[j,i] then write(pfile,'M') else write(pfile,'1')
       end (* digr *) else write(pfile,'1');
       end (* mat *) else write(pfile,'0');
    writeln(pfile);
   end; (* i *)
 write(pfile,'* ');
 for i :=1 to numf do write(pfile,rfv[i]:6:2,' ');
 writeln(pfile);
 end; (* Listmat *)

  {
procedure Listmatz(var pfile: textfile; mat,z:Incid; rff: rFuncvalue);
var i,j: byte;
begin
  writeln(pfile); write(pfile,'    ');
  for i:= 1 to g do write(pfile,ct[i]:3);
  writeln(pfile);
  for i := 1 to g do begin
    write(pfile,rt[i]:3,' ');
    for j:= 1 to i-1 do
      if z[i,j] then begin
        if mat[i,j] then write(pfile,'  I')  else write(pfile,'  O') end else begin
      if mat[i,j] then begin
        if mat[j,i] then write(pfile,'  M') else write(pfile,'  1')
       end else write(pfile,'   '); end;
    write(pfile,'  X');
    for j:= i+1 to g do
      if z[i,j] then begin
        if mat[i,j] then write(pfile,'  I')  else write(pfile,'  O') end else begin
      if mat[i,j] then begin
        if mat[j,i] then write(pfile,'  M') else write(pfile,'  1')
       end else write(pfile,'   '); end;
    writeln(pfile);
   end; (* i *)
 writeln(pfile);
 for i :=1 to numf do
   writeln(pfile,'Function value ',i:2,' = ',rff[i]:6:2);
 end; (* Listmatz *)
 }

procedure Update(var rfout: RFuncvalue);
var ff: Integer;
    fv: Funcvalue;
    rfv: rFuncvalue;
    nf: Byte;
begin
  Inc(s00);
  Func(fversion,fv,rfv);
  rfout := rfv;
  for nf := numf downto 1 do begin
    ff := fv[nf];
    s0[2,nf] := s0[2,nf] + sqr(ff);
    s0[1,nf] := s0[1,nf] + ff;
    if ((ff >= m1) and (ff <= m2)) then
      begin
        s[ff,nf]  := s[ff,nf] + 1.0;
        if ff > m4[nf] then m4[nf] := ff;
        if ff < m3[nf] then m3[nf] := ff;
       end else begin
        if (ff > m2) then large[nf]:= true else small[nf] := true; end;
     end;  (* nf *)
end;     (* Update *)

procedure Giveresult(var outf: textfile);
var j,rang,barnum: Integer;
    i,ii,nf: Byte;
    mean: array[m1..m2] of Real;
    mean0: array[1..m01] of Real;
    summean,sd: Ress;
begin
  heading(2,outf,'Enumeration results.');
  if connect then
 writeln(outf,'Number of disconnected matrices constructed is ',Ndisconn,'.');
  writeln(outf,'Total number of matrices found  ',s00:8);
  if s00 <= 0 then Exit;
  for nf := 1 to numf do begin
    for i:= m1 to m2 do
      begin
        mean[i] := s[i,nf]/s00;
       end;
    for i:= 1 to 2 do mean0[i] := s0[i,nf]/s00;
 (* Here we use m01 = 2 ! *)
     mean0[2] := mean0[2] - sqr(mean0[1]);
     Heading(3,outf,Tex(fversion,nf,true));
     writeln(outf,'Mean               ', mean0[1]:8:4);
     writeln(outf,'Variance           ', mean0[2]:8:4);
     writeln(outf,'Standard deviation ', root(mean0[2]):8:4);
     if small[nf] then
       writeln(outf,'Some outcomes were less than ', m1);
     if large[nf] then writeln(outf,'Some outcomes were greater than ',m2);
     if (m4[nf] >=m3[nf]) then begin
       writeln(outf);
       writeln(outf,'Outcome        Number of matrices');
       for i := m3[nf] to m4[nf] do
         if (s[i,nf] > 0.5) then writeln(outf,i:7,'      ',s[i,nf]:12:0);
       writeln(outf);
      end; (* if m4 >= m3 *)
     if (m4[nf] > m3[nf]) then begin
       rang := ((m4[nf]-m3[nf]) div 70) + 1;
       barnum := (m4[nf]-m3[nf]+1) div rang;
       if rang*barnum < m4[nf]-m3[nf]+1 then barnum := barnum + 1;
       if (barnum > 70) then barnum := 70;
       j := m3[nf]-1;
       for i:=1 to barnum do begin
         summean[i] := 0.0;
         sd[i] := 0.0;
         for ii := 1 to rang do begin
           j := j+1;
           if (j <= m2) then summean[i] := summean[i]+mean[j]; end;
        end;
       Barchart(outf,1,rang,barnum,m3[nf],summean,sd);
     end; (* if m4 > m3 *)
    end; (* nf *)
   writeln(outf);
   if printall then writeln(outf,'All matrices written to file ',pfname,'.');
   if funcerror then writeln(outf,'There were errors in function evaluation.');
end;      (* Giveresult *)

begin (* unit Zoelib *)
end.
